
-- Write BPM. version 2.7.0 -syflom

renoise.tool():add_menu_entry {
  name = "Pattern Editor:Write BPM to Master column",
  invoke = function() write_bpm() end 
}

renoise.tool():add_keybinding {
  name = "Pattern Editor:Pattern:Write BPM to Master column",
  invoke = function() write_bpm() end
}

function get_master_track_index()
  for k,v in ripairs(renoise.song().tracks)
    do if v.type == renoise.Track.TRACK_TYPE_MASTER then return k end  
  end
end

function write_bpm()
  if renoise.song().transport.bpm < 256 then -- safety check
    local column_index = renoise.song().selected_effect_column_index
    if renoise.song().selected_effect_column_index <= 1 then column_index = 1 end
    renoise.song().selected_pattern.tracks[get_master_track_index()].lines[1].effect_columns[column_index].number_string = "F0"
    renoise.song().selected_pattern.tracks[get_master_track_index()].lines[1].effect_columns[column_index].amount_value = renoise.song().transport.bpm
  end
end

-- † --
